num = (s) -> if s == '' or isNaN(parseInt(s)) then 0 else parseInt(s)

$ ->
    $('.match-editable').each ->
        table = $(@)
        match_total = table.find('.match-total')
        match_avg = table.find('.match-avg')
        inputs = table.find('input')

        sum_row = (row) ->
            row_total = 0
            prev_total = 0
            incomplete = false

            row.find('input').each ->
                if $(@).val() == ''
                    incomplete = true
                    return false

                row_total += num($(@).val())

            if incomplete
                return

            if prev_row = row.prev('tr')
                prev_total = num(prev_row.children('.total').text())

            row.children('.row-total').text(row_total)
            row.children('.total').text(prev_total + row_total)
            row.children('.total').text(prev_total + row_total)

        inputs.on 'change keyup', ->
            sum = 0
            count = 0

            inputs.each ->
                if $(@).val() != ''
                    sum += num($(@).val())
                    count++

            sum_row($(@).closest('tr'))

            match_total.text(sum)
            match_avg.text(Math.round(sum / count * 10) / 10)

            cell = $(@).closest('td')
            cls = cell.attr('class').replace(/\s*val-\d+\s*/, '')
            cell.attr('class', cls).addClass('val-' + $(@).val())

        inputs.filter('[value=""]:first').focus()

    $('textarea').on 'keyup', ->
        $(@).height(0).height($(@).prop('scrollHeight'))

        desired_scroll = $(@).offset().top - 60

        if $(document).scrollTop() < desired_scroll
            $(window).scrollTop(desired_scroll)
    .keyup()

    $('#toggle-colored').on 'click', ->
        $(@).toggleClass('active').blur()
        $('#match').toggleClass('colored')

        if $('#match').hasClass('colored') and window.hasOwnProperty('localStorage')
            localStorage.setItem('colored-scores', true)
            console.log localStorage.getItem('colored-scores')
        else
            localStorage.removeItem('colored-scores')

    if window.hasOwnProperty('localStorage') and localStorage.getItem('colored-scores')
        $('#match').addClass('colored')
        $('#toggle-colored').addClass('active')
